
/******************************************************************************
 ******************************************************************************/

/** \file test.yada.h
 *  automatically generated from: test.yada
 */

#ifndef __YADAC_TEST_H__
#define __YADAC_TEST_H__

/******************************************************************************
 * I N C L U D E S ************************************************************
 ******************************************************************************/

#include <yada.h>

#include "testruct.h"

/******************************************************************************
 * T Y P E D E F S ************************************************************
 ******************************************************************************/

#ifndef __YADAC_T_
#define __YADAC_T_

typedef struct
{
  yada_t *db;
  int sz;
  int rcs;
  yada_rc_t **rc;
} yadac_t;

#endif

/******************************************************************************
 * P R O T O T Y P E S ********************************************************
 ******************************************************************************/

/* init / destroy test functions */
yadac_t* test_init(yadac_t *db, ...);
void test_free(yadac_t *yc);

void test_destroy(yadac_t *yc);

/* compiled queries */
int test_create_table(yadac_t *yc, char *in1);

int test_drop_table(yadac_t *yc);

int test_addrow(yadac_t *yc, char *in1, int in2, char *in3);

int test_addrowstruct(yadac_t *yc, testruct_t *in);

int test_getid(yadac_t *yc, int errval, char *in1);

char* test_getstr(yadac_t *yc, char *errval, int in1);

int test_findrow(yadac_t *yc, int in1, int in2, int *out1, char *out2, int *out3, int **out4, char **out5);

int test_findstruct(yadac_t *yc, int in1, int in2, testruct_t *out);

int test_findmatch(yadac_t *yc, int in1, int *out1, char **out2);
int test_findmatch_fetch(yadac_t *yc);
int test_matchstruct(yadac_t *yc, int in1, testruct_t *out);

int test_matchstruct_fetch(yadac_t *yc);
/******************************************************************************/

#endif /* end __YADAC_TEST_H__ */

/******************************************************************************
 ******************************************************************************/

